#include <windows.h>
#include "../wdl/jnetlib/connection.h"

#include "portscan.h"

static int m_portstate;
static DWORD m_con_start_t;
static JNL_Connection *m_con;

int run_portscan(MonitoredHost *host)
{
  if (!host) 
  {
    delete m_con;
    m_portstate=0;
    m_con=0;
    
    // reset state
    return 0;
  }

  if (!m_con)
  {
    int port=0;

    switch (m_portstate)
    {
      case 0:
        port=80;
      break;
      case 1:
        port=139;
      break;
      default:
      break;
    }
    if (!port) 
    {
      host->m_has_scanned=1;
      return 1;
    }

    m_con_start_t=GetTickCount();

    m_con=new JNL_Connection(NULL,1024,4096);

    char buf[512];
    int ip=host->m_address;
    wsprintf(buf,"%d.%d.%d.%d",(ip>>24)&0xff,(ip>>16)&0xff,(ip>>8)&0xff,(ip)&0xff);
  
    m_con->connect(buf,port);

    switch (m_portstate)
    {
      case 0:
        m_con->send_string("GET / HTTP/1.0\r\n"
                           "User-Agent: LanMon/0.0\r\n"
                           "\r\n");
      break;
      default:
      break;
    }
  }

  if (m_con)
  {
    m_con->run();

    int s=m_con->get_state();
    if (s >= JNL_Connection::STATE_CONNECTED)
    {
      switch (m_portstate)
      {
        case 0:
          {
            int found=0;
            while (m_con->recv_lines_available()>1)
            {
              char line[1024];
              m_con->recv_line(line,sizeof(line));
              if (!line[0]) 
              {
                found++;
                break;
              }

              if (!strnicmp(line,"Server:",7))
              {
                char *p=line+7;
                while (*p == ' ') p++;
                if (*p)
                {
                  host->m_has_httpd=strdup(p);
                }
                else 
                  host->m_has_httpd=strdup("Unknown");

                found++;
                break;
              }
              if (!strnicmp(line,"WWW-Authenticate:",17))
              {
                char *p=line+17;
                while (*p && strnicmp(p,"realm=",6)) p++;
                if (*p)
                {
                  host->m_has_httpd=strdup(p);
                }
                else
                {
                  host->m_has_httpd=strdup("Need Authorization");
                }
                found++;
                break;
              }
            }


            if (!found && GetTickCount() < m_con_start_t+1000)
              return 0;

          }

        break;
        case 1:
          // return 0 while doing shit
          host->m_has_netbiosssn=1;
        break;
        default:
        break;
      }
    
      delete m_con;
      m_con=0;
      m_portstate++;
    }
    else if (s < JNL_Connection::STATE_CONNECTING || GetTickCount() > m_con_start_t+500)
    {
      delete m_con;
      m_con=0;
      m_portstate++;
    }
  }
  return 0;
}


void portscan_init()
{
}

void portscan_quit()
{
}